UNIT LZH_S;

{ DEFINE DEBUGLZH}

INTERFACE

USES GMemory;


CONST
     {These constants are hard coded into LZHASM.OBJ}
   N         = $1000             ; {Size of string buffer}
   F         = 60                ; {60 Size of look-ahead buffer}

TYPE
  IObuf = ARRAY[0..$2800-1] OF byte;

  LZHRec = RECORD       {Segment:0 Aligned}
    WorkSpace1 : ARRAY[0..N+F-1] OF Byte;
    Count      : LongInt;
    Textsize   : LongInt;
    Codesize   : LongInt;
    Inptr      : Word;
    Inend      : Word;
    Outptr     : Word;
    Outend     : Word;
    Ebytes     : Longint;
    InBuf      : IOBuf;
    OutBuf     : IObuf;
    {Buffersize and position are critical}
    WorkSpace  : ARRAY[0..$73FF] OF Byte;
    {LZHASM work space} {Some space reserved}
  END;


VAR
 {$F+}
   LZHError       : Word;
   WriteFromBuffer: PROCEDURE;
   ReadToBuffer   : PROCEDURE;
   LZHMem         : ^LZHRec;
   LZHMemSeg      : Word;
 {$F+}


PROCEDURE Encode;
PROCEDURE Decode;

PROCEDURE InitLZH;
PROCEDURE DInitLZH;



IMPLEMENTATION


{$F+}
PROCEDURE Decode; EXTERNAL;
PROCEDURE Encode; EXTERNAL; {$L C:\GFSOFT\GUNITS\LZHASM.OBJ}



{$R-}
PROCEDURE InitLZH;
{ If need be, call this routine before any other allocations, or...
  Segment align all allocations.  This routine is setup to keep memory
  allocations segment aligned, and to be backwards compatible with all
  versions of Turbo Pascal}
BEGIN
   mAlloc(LZHMem, (Sizeof(LZhmem^) AND $FFF0)+16);
   {GetMem(LZHMem, (Sizeof(LZhmem^) AND $FFF0)+16);}
   LZHMemSeg := Seg(LZhmem^);
   LZhmem^.Inend := 0;  { This is to insure that Read is called.      }
   LZhmem^.outend := 0; { If you don't fill the input, the engine will}
   {If you wonder why it locks up at any point, this is probably the cause}
   {If you changed this source, it's probably your fault.}

   {$IFDEF DEBUGLZH}
   Writeln (Seg(LZhmem^),':',Ofs(LZhmem^));
   Writeln (SizeOf(LZhmem^));
   Halt;
   {$ENDIF}
END;


PROCEDURE DInitLZH;
BEGIN
  dAlloc(LZHMem);
  {FreeMem(LZHMem, (Sizeof(LZhmem^) AND $FFF0) + 16);}
END;


END.
